// Copyright 2018 The Go Authors. All rights reserved.
// Use of this source code is governed by a BSD-style
// license that can be found in the LICENSE file.

// Translations from Frank da Cruz, Ethan Mollick, and many others.
// See http://kermitproject.org/utf8.html.
// http://www.oocities.org/nodotus/hbglass.html
// https://en.wikipedia.org/wiki/I_Can_Eat_Glass

package sampler

var glass = newText(`

English: en: I can eat glass and it doesn't hurt me.

Afrikaans: af: Ek kan glas eet, maar dit doen my nie skade nie.
Albanian: sq: Unë mund të ha qelq dhe nuk më gjen gjë.
Allemannisch: gsw: I kaun Gloos essen, es tuat ma ned weh.
Anglo-Saxon (Latin): ang-Latn: Ic mæg glæs eotan ond hit ne hearmiað me.
Anglo-Saxon (Runes): ang-Runr: ᛁᚳ᛫ᛗᚨᚷ᛫ᚷᛚᚨᛋ᛫ᛖᚩᛏᚪᚾ᛫ᚩᚾᛞ᛫ᚻᛁᛏ᛫ᚾᛖ᛫ᚻᛖᚪᚱᛗᛁᚪᚧ᛫ᛗᛖ᛬
Arabic(3): ar: أنا قادر على أكل الزجاج و هذا لا يؤلمني. 
Aragonés: an: Puedo minchar beire, no me'n fa mal . 
Armenian: hy: Կրնամ ապակի ուտել և ինծի անհանգիստ չըներ։
Bangla / Bengali: bn: আমি কাঁচ খেতে পারি, তাতে আমার কোনো ক্ষতি হয় না।
Basque: eu: Kristala jan dezaket, ez dit minik ematen.
Bayrisch / Bavarian: bar: I koh Glos esa, und es duard ma ned wei.
Belarusian (Cyrillic): be-Cyrl: Я магу есці шкло, яно мне не шкодзіць.
Belarusian (Lacinka): be-Latn: Ja mahu jeści škło, jano mne ne škodzić.
Bislama: bi: Mi save kakae glas, hemi no save katem mi.
Bosnian, Croatian, Montenegrin and Serbian (Latin): bs-Latn: Ja mogu jesti staklo, i to mi ne šteti.
Bosnian, Montenegrin and Serbian (Cyrillic): bs-Cyrl: Ја могу јести стакло, и то ми не штети.
Brazilian Portuguese (8): pt-BR: Posso comer vidro, não me machuca.
Bulgarian: bg: Мога да ям стъкло, то не ми вреди.
Burmese (Unicode 5.0): my: ကျွန်တော် ကျွန်မ မှန်စားနိုင်တယ်။ ၎င်းကြောင့် ထိခိုက်မှုမရှိပါ။ (9)
Caboverdiano/Kabuverdianu (Cape Verde): kea: M' podê cumê vidru, ca ta maguâ-m'.
Catalan / Català: ca: Puc menjar vidre, que no em fa mal.
Chamorro: ch: Siña yo' chumocho krestat, ti ha na'lalamen yo'.
Chinese (Traditional): zh-Hant: 我能吞下玻璃而不傷身體。
Chinese: zh-Hans: 我能吞下玻璃而不伤身体。
Chinook Jargon: chn: Naika məkmək kakshət labutay, pi weyk ukuk munk-sik nay.
Classical Greek: grc: ὕαλον ϕαγεῖν δύναμαι· τοῦτο οὔ με βλάπτει.
Cornish: kw: Mý a yl dybry gwéder hag éf ny wra ow ankenya.
Czech: cs: Mohu jíst sklo, neublíží mi.
Dansk / Danish: da: Jeg kan spise glas, det gør ikke ondt på mig.
Deutsch (Voralberg): I ka glas eassa, ohne dass mar weh tuat.
Deutsch / German: de: Ich kann Glas essen, ohne mir zu schaden.
English (Braille): en-Brai: ⠊⠀⠉⠁⠝⠀⠑⠁⠞⠀⠛⠇⠁⠎⠎⠀⠁⠝⠙⠀⠊⠞⠀⠙⠕⠑⠎⠝⠞⠀⠓⠥⠗⠞⠀⠍⠑
English (IPA): [aɪ kæn iːt glɑːs ænd ɪt dɐz nɒt hɜːt miː] (Received Pronunciation)
Erzian: myv: Мон ярсан суликадо, ды зыян эйстэнзэ а ули.
Esperanto: eo: Mi povas manĝi vitron, ĝi ne damaĝas min. 
Estonian: et: Ma võin klaasi süüa, see ei tee mulle midagi.
European Portuguese: pt: Posso comer vidro, não me faz mal.
Farsi / Persian(3): fa: .من می توانم بدونِ احساس درد شيشه بخورم
Fijian: fj: Au rawa ni kana iloilo, ia au sega ni vakacacani kina.
French: fr: Je peux manger du verre, ça ne me fait pas mal.
Frysk / Frisian: fy: Ik kin glês ite, it docht me net sear.
Føroyskt / Faroese: fo: Eg kann eta glas, skaðaleysur.
Galician: gl: Eu podo xantar cristais e non cortarme.
Georgian: ka: მინას ვჭამ და არა მტკივა.
Gothic (4): got: 𐌼𐌰𐌲 𐌲𐌻𐌴𐍃 𐌹̈𐍄𐌰𐌽, 𐌽𐌹 𐌼𐌹𐍃 𐍅𐌿 𐌽𐌳𐌰𐌽 𐌱𐍂𐌹𐌲𐌲𐌹𐌸.
Greek (monotonic): el: Μπορώ να φάω σπασμένα γυαλιά χωρίς να πάθω τίποτα.
Greek (polytonic): el-poly: Μπορῶ νὰ φάω σπασμένα γυαλιὰ χωρὶς νὰ πάθω τίποτα. 
Hausa (Ajami) (2): ha-Arab: إِنا إِىَ تَونَر غِلَاشِ كُمَ إِن غَمَا لَافِىَا
Hausa (Latin): ha: Inā iya taunar gilāshi kuma in gamā lāfiyā.
Hawaiian: haw: Hiki iaʻu ke ʻai i ke aniani; ʻaʻole nō lā au e ʻeha.
Hebrew(3): he: RTL אני יכול לאכול זכוכית וזה לא מזיק לי.
Hindi: hi: मैं काँच खा सकता हूँ और मुझे उससे कोई चोट नहीं पहुंचती.
Hungarian: hu: Meg tudom enni az üveget, nem lesz tőle bajom.
Inuktitut (10): iku: ᐊᓕᒍᖅ ᓂᕆᔭᕌᖓᒃᑯ ᓱᕋᙱᑦᑐᓐᓇᖅᑐᖓ
Irish: ga: Is féidir liom gloinne a ithe. Ní dhéanann sí dochar ar bith dom.
Italian: it: Posso mangiare il vetro e non mi fa male.
Jamaican: jam: Mi kian niam glas han i neba hot mi.
Japanese: ja: 私はガラスを食べられます。それは私を傷つけません。
Javanese: jv: Aku isa mangan beling tanpa lara.
Kannada: kn: ನನಗೆ ಹಾನಿ ಆಗದೆ, ನಾನು ಗಜನ್ನು ತಿನಬಹುದು
Khmer: km: ខ្ញុំអាចញុំកញ្ចក់បាន ដោយគ្មានបញ្ហារ
Kirchröadsj/Bôchesserplat: Iech ken glaas èèse, mer 't deet miech jing pieng.
Korean: ko: 나는 유리를 먹을 수 있어요. 그래도 아프지 않아요
Kreyòl Ayisyen (Haitï): ht: Mwen kap manje vè, li pa blese'm.
Lalland Scots / Doric: sco: Ah can eat gless, it disnae hurt us. 
Langenfelder Platt: Isch kann Jlaas kimmeln, uuhne datt mich datt weh dääd.
Lao: lo: ຂອ້ຍກິນແກ້ວໄດ້ໂດຍທີ່ມັນບໍ່ໄດ້ເຮັດໃຫ້ຂອ້ຍເຈັບ.
Latin: la: Vitrum edere possum; mihi non nocet.
Latvian: lv: Es varu ēst stiklu, tas man nekaitē.
Lausitzer Mundart ("Lusatian"): wen: Ich koann Gloos assn und doas dudd merr ni wii.
Lingala: lin: Nakokí kolíya biténi bya milungi, ekosála ngáí mabé tɛ́.
Lithuanian: lt: Aš galiu valgyti stiklą ir jis manęs nežeidžia 
Lojban: jbo: mi kakne le nu citka le blaci .iku'i le se go'i na xrani mi
Lëtzebuergescht / Luxemburgish: lb: Ech kan Glas iessen, daat deet mir nët wei.
Macedonian: mk: Можам да јадам стакло, а не ме штета.
Malay: ms: Saya boleh makan kaca dan ia tidak mencederakan saya.
Malayalam: ml: എനിക്ക് ഗ്ലാസ് തിന്നാം. അതെന്നെ വേദനിപ്പിക്കില്ല.
Maltese: mt: Nista' niekol il-ħġieġ u ma jagħmilli xejn.
Manx Gaelic: gv: Foddym gee glonney agh cha jean eh gortaghey mee.
Marathi: mr: मी काच खाऊ शकतो, मला ते दुखत नाही.
Marquesan: mrq: E koʻana e kai i te karahi, mea ʻā, ʻaʻe hauhau.
Middle English: enm: Ich canne glas eten and hit hirtiþ me nouȝt.
Milanese: Sôn bôn de magnà el véder, el me fa minga mal.
Mongolian (Classic) (5): mn: ᠪᠢ ᠰᠢᠯᠢ ᠢᠳᠡᠶᠦ ᠴᠢᠳᠠᠨᠠ ᠂ ᠨᠠᠳᠤᠷ ᠬᠣᠤᠷᠠᠳᠠᠢ ᠪᠢᠰᠢ 
Mongolian (Cyrillic): mn-Cyrl: Би шил идэй чадна, надад хортой биш
Napoletano: nap: M' pozz magna' o'vetr, e nun m' fa mal.
Navajo: nv: Tsésǫʼ yishą́ągo bííníshghah dóó doo shił neezgai da. 
Nederlands / Dutch: nl: Ik kan glas eten, het doet mĳ geen kwaad.
Nepali: ne: म काँच खान सक्छू र मलाई केहि नी हुन्‍न् ।
Norsk / Norwegian (Bokmål): nb: Jeg kan spise glass uten å skade meg.
Norsk / Norwegian (Nynorsk): nn: Eg kan eta glas utan å skada meg.
Northern Karelian: krl: Mie voin syvvä lasie ta minla ei ole kipie.
Nórdicg: Ljœr ye caudran créneþ ý jor cẃran.
Odenwälderisch: Iech konn glaasch voschbachteln ohne dass es mir ebbs daun doun dud.
Old French: fro: Je puis mangier del voirre. Ne me nuit.
Old Irish (Latin): sga: Con·iccim ithi nglano. Ním·géna.
Old Irish (Ogham): sga-Ogam: ᚛᚛ᚉᚑᚅᚔᚉᚉᚔᚋ ᚔᚈᚔ ᚍᚂᚐᚅᚑ ᚅᚔᚋᚌᚓᚅᚐ᚜
Old Norse (Latin): non: Ek get etið gler án þess að verða sár.
Old Norse (Runes): non-Runr: ᛖᚴ ᚷᛖᛏ ᛖᛏᛁ ᚧ ᚷᛚᛖᚱ ᛘᚾ ᚦᛖᛋᛋ ᚨᚧ ᚡᛖ ᚱᚧᚨ ᛋᚨᚱ
Papiamentu: pap: Ami por kome glas anto e no ta hasimi daño.
Pashto(3): pt: زه شيشه خوړلې شم، هغه ما نه خوږوي
Pfälzisch: pfl: Isch konn Glass fresse ohne dasses mer ebbes ausmache dud.
Picard: pcd: Ch'peux mingi du verre, cha m'foé mie n'ma. 
Polska / Polish: pl: Mogę jeść szkło i mi nie szkodzi.
Provençal / Occitan: Pòdi manjar de veire, me nafrariá pas.
Québécois: J'peux manger d'la vitre, ça m'fa pas mal.
Roman: frp: Me posso magna' er vetro, e nun me fa male.
Romanian: ro: Pot să mănânc sticlă și ea nu mă rănește.
Romansch (Grischun): rm: Jau sai mangiar vaider, senza che quai fa donn a mai. 
Ruhrdeutsch: Ich kann Glas verkasematuckeln, ohne dattet mich wat jucken tut.
Russian: ru: Я могу есть стекло, оно мне не вредит.
Sami (Northern): se: Sáhtán borrat lása, dat ii leat bávččas.
Sanskrit (standard transcription): sa: kācaṃ śaknomyattum; nopahinasti mām.
Sanskrit: sa-Runr: काचं शक्नोम्यत्तुम् । नोपहिनस्ति माम् ॥
Schwyzerdütsch (Luzern): gsw: Ech cha Glâs ässe, das schadt mer ned. 
Schwyzerdütsch (Zürich): gsw: Ich chan Glaas ässe, das schadt mir nöd.
Schwäbisch / Swabian: I kå Glas frässa, ond des macht mr nix!
Scottish Gaelic: gd: S urrainn dhomh gloinne ithe; cha ghoirtich i mi.
Sicilian: scn: Puotsu mangiari u vitru, nun mi fa mali. 
Sinhalese: si: මට වීදුරු කෑමට හැකියි. එයින් මට කිසි හානියක් සිදු නොවේ.
Slovak: sk: Môžem jesť sklo. Nezraní ma.
Slovenian: sl: Lahko jem steklo, ne da bi mi škodovalo.
Southern Karelian: olo: Minä voin syvvä st'oklua dai minule ei ole kibie. 
Spanish: es: Puedo comer vidrio, no me hace daño.
Suomi / Finnish: fi: Voin syödä lasia, se ei vahingoita minua.
Svenska / Swedish: sv: Jag kan äta glas utan att skada mig.
Sächsisch / Saxon: sxu: 'sch kann Glos essn, ohne dass'sch mer wehtue.
Sønderjysk: Æ ka æe glass uhen at det go mæ naue.
Swahili: sw: Naweza kula bilauri na sikunyui.
Tagalog: tl: Kaya kong kumain nang bubog at hindi ako masaktan.
Taiwanese(6): Góa ē-tàng chia̍h po-lê, mā bē tio̍h-siong.
Tamil: ta: நான் கண்ணாடி சாப்பிடுவேன், அதனால் எனக்கு ஒரு கேடும் வராது.
Tatar: tt: Алам да бар, пыяла, әмма бу ранит мине.
Telugu: te: నేను గాజు తినగలను మరియు అలా చేసినా నాకు ఏమి ఇబ్బంది లేదు
Thai: th: ฉันกินกระจกได้ แต่มันไม่ทำให้ฉันเจ็บ
Tibetan: bo: ཤེལ་སྒོ་ཟ་ནས་ང་ན་གི་མ་རེད།
Turkish (Ottoman): جام ييه بلورم بڭا ضررى طوقونمز
Turkish: tr: Cam yiyebilirim, bana zararı dokunmaz.
Twi: tw: Metumi awe tumpan, ɜnyɜ me hwee.
Ukrainian: uk: Я можу їсти скло, і воно мені не зашкодить.
Ulster Gaelic: Ithim-sa gloine agus ní miste damh é.
Urdu(3): ur: میں کانچ کھا سکتا ہوں اور مجھے تکلیف نہیں ہوتی ۔
Uzbek / O’zbekcha: (Roman): uz: Men shisha yeyishim mumkin, ammo u menga zarar keltirmaydi.
Uzbek / Ўзбекча (Cyrillic): uz-Cyrl: Мен шиша ейишим мумкин, аммо у менга зарар келтирмайди.
Venetian: vec: Mi posso magnare el vetro, no'l me fa mae.
Vietnamese (nôm) (4): 些 𣎏 世 咹 水 晶 𦓡 空 𣎏 害 咦
Vietnamese (quốc ngữ): vi: Tôi có thể ăn thủy tinh mà không hại gì.
Walloon: wa: Dji pou magnî do vêre, çoula m' freut nén må. 
Welsh: cy: Dw i'n gallu bwyta gwydr, 'dyw e ddim yn gwneud dolur i mi.
Yiddish(3): yi: RTL איך קען עסן גלאָז און עס טוט מיר נישט װײ. 
Yoruba(4): yo: Mo lè je̩ dígí, kò ní pa mí lára.
Zeneise (Genovese): Pòsso mangiâ o veddro e o no me fà mâ.
Íslenska / Icelandic: is: Ég get etið gler án þess að meiða mig.

`)
